Index: src/unittests/analysisbondsunittest.cpp
===================================================================
--- src/unittests/analysisbondsunittest.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/unittests/analysisbondsunittest.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -14,5 +14,8 @@
 #include <iostream>
 #include <stdio.h>
+#include <cstring>
 
+#include "analysis_bonds.hpp"
+#include "analysisbondsunittest.hpp"
 #include "atom.hpp"
 #include "bond.hpp"
@@ -21,5 +24,4 @@
 #include "molecule.hpp"
 #include "periodentafel.hpp"
-#include "analysisbondsunittest.hpp"
 
 /********************************************** Test classes **************************************/
@@ -41,8 +43,12 @@
   hydrogen = new element;
   hydrogen->Z = 1;
+  hydrogen->Valence = 1;
+  hydrogen->NoValenceOrbitals = 1;
   strcpy(hydrogen->name, "hydrogen");
   strcpy(hydrogen->symbol, "H");
   carbon = new element;
   carbon->Z = 2;
+  carbon->Valence = 4;
+  carbon->NoValenceOrbitals = 4;
   strcpy(carbon->name, "carbon");
   strcpy(carbon->symbol, "C");
@@ -58,13 +64,13 @@
   Walker = new atom();
   Walker->type = hydrogen;
-  Walker->node->Init(1., 0., 1. );
+  Walker->node->Init(1.5, 0., 1.5 );
   TestMolecule->AddAtom(Walker);
   Walker = new atom();
   Walker->type = hydrogen;
-  Walker->node->Init(0., 1., 1. );
+  Walker->node->Init(0., 1.5, 1.5 );
   TestMolecule->AddAtom(Walker);
   Walker = new atom();
   Walker->type = hydrogen;
-  Walker->node->Init(1., 1., 0. );
+  Walker->node->Init(1.5, 1.5, 0. );
   TestMolecule->AddAtom(Walker);
   Walker = new atom();
@@ -72,7 +78,11 @@
   Walker->node->Init(0., 0., 0. );
   TestMolecule->AddAtom(Walker);
+  Walker = new atom();
+  Walker->type = carbon;
+  Walker->node->Init(0.5, 0.5, 0.5 );
+  TestMolecule->AddAtom(Walker);
 
   // check that TestMolecule was correctly constructed
-  CPPUNIT_ASSERT_EQUAL( TestMolecule->AtomCount, 4 );
+  CPPUNIT_ASSERT_EQUAL( TestMolecule->AtomCount, 5 );
 
   // create a small file with table
@@ -82,5 +92,13 @@
   test << "H\t1.\t1.2\n";
   test << "C\t1.2\t1.5\n";
+  test.close();
   BG = new BondGraph(true);
+
+  CPPUNIT_ASSERT_EQUAL( true , BG->LoadBondLengthTable(*filename) );
+  CPPUNIT_ASSERT_EQUAL( 1., BG->GetBondLength(0,0) );
+  CPPUNIT_ASSERT_EQUAL( 1.2, BG->GetBondLength(0,1) );
+  CPPUNIT_ASSERT_EQUAL( 1.5, BG->GetBondLength(1,1) );
+
+  BG->ConstructBondGraph(TestMolecule);
 };
 
@@ -100,16 +118,50 @@
 };
 
-/** UnitTest for AnalysisBondsTest::LoadBondLengthTable().
+/** UnitTest for GetMaxMinMeanBondCount().
  */
-void AnalysisBondsTest::BondsTest()
+void AnalysisBondsTest::GetMaxMinMeanBondCountTest()
 {
-  CPPUNIT_ASSERT_EQUAL( true , BG->LoadBondLengthTable(*filename) );
-  CPPUNIT_ASSERT_EQUAL( 1., BG->GetBondLength(0,0) );
-  CPPUNIT_ASSERT_EQUAL( 1.2, BG->GetBondLength(0,1) );
-  CPPUNIT_ASSERT_EQUAL( 1.5, BG->GetBondLength(1,1) );
-
-  CPPUNIT_ASSERT_EQUAL( true , true );
+  double Min = 20.; // check that initialization resets these arbitrary values
+  double Mean = 200.;
+  double Max = 1e-6;
+  GetMaxMinMeanBondCount(TestMolecule, Min, Mean, Max);
+  CPPUNIT_ASSERT_EQUAL( 1., Min );
+  CPPUNIT_ASSERT_EQUAL( 1.6, Mean );
+  CPPUNIT_ASSERT_EQUAL( 4., Max );
 
 };
+
+/** UnitTest for MinMaxBondDistanceBetweenElements().
+ */
+void AnalysisBondsTest::MinMeanMaxBondDistanceBetweenElementsTest()
+{
+  double Min = 20.; // check that initialization resets these arbitrary values
+  double Mean = 2e+6;
+  double Max = 1e-6;
+  double Min2 = 20.;
+  double Mean2 = 2e+6;
+  double Max2 = 1e-6;
+  const double maxbondlength = sqrt(1.*1. + 1.*1. + .5*.5);
+  const double minbondlength = sqrt(.5*.5 + .5*.5 + .5*.5);
+  const double meanbondlength = (minbondlength+3.*maxbondlength)/4.;
+  // check bond lengths C-H
+  MinMeanMaxBondDistanceBetweenElements(TestMolecule, hydrogen, carbon, Min, Mean, Max);
+  CPPUNIT_ASSERT_EQUAL( minbondlength , Min );
+  CPPUNIT_ASSERT_EQUAL( meanbondlength , Mean );
+  CPPUNIT_ASSERT_EQUAL( maxbondlength , Max );
+
+  // check that elements are symmetric, i.e. C-H == H-C
+  MinMeanMaxBondDistanceBetweenElements(TestMolecule, carbon, hydrogen, Min2, Mean2, Max2);
+  CPPUNIT_ASSERT_EQUAL( Min , Min2 );
+  CPPUNIT_ASSERT_EQUAL( Mean , Mean2 );
+  CPPUNIT_ASSERT_EQUAL( Max , Max2 );
+
+  // check no bond case (no bonds H-H in system!)
+  MinMeanMaxBondDistanceBetweenElements(TestMolecule, hydrogen, hydrogen, Min, Mean, Max);
+  CPPUNIT_ASSERT_EQUAL( 0. , Min );
+  CPPUNIT_ASSERT_EQUAL( 0. , Mean );
+  CPPUNIT_ASSERT_EQUAL( 0. , Max );
+};
+
 
 /********************************************** Main routine **************************************/
Index: src/unittests/analysisbondsunittest.hpp
===================================================================
--- src/unittests/analysisbondsunittest.hpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/unittests/analysisbondsunittest.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -11,6 +11,5 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#include "bondgraph.hpp"
-
+class BondGraph;
 class element;
 class molecule;
@@ -22,5 +21,6 @@
 {
     CPPUNIT_TEST_SUITE( AnalysisBondsTest) ;
-    CPPUNIT_TEST ( BondsTest );
+    CPPUNIT_TEST ( GetMaxMinMeanBondCountTest );
+    CPPUNIT_TEST ( MinMeanMaxBondDistanceBetweenElementsTest );
     CPPUNIT_TEST_SUITE_END();
 
@@ -28,5 +28,6 @@
       void setUp();
       void tearDown();
-      void BondsTest();
+      void GetMaxMinMeanBondCountTest();
+      void MinMeanMaxBondDistanceBetweenElementsTest();
 
 private:
Index: src/unittests/bondgraphunittest.cpp
===================================================================
--- src/unittests/bondgraphunittest.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/unittests/bondgraphunittest.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -14,4 +14,5 @@
 #include <iostream>
 #include <stdio.h>
+#include <cstring>
 
 #include "atom.hpp"
@@ -19,4 +20,5 @@
 #include "bondgraph.hpp"
 #include "element.hpp"
+#include "log.hpp"
 #include "molecule.hpp"
 #include "periodentafel.hpp"
@@ -41,8 +43,12 @@
   hydrogen = new element;
   hydrogen->Z = 1;
+  hydrogen->CovalentRadius = 0.23;
+  hydrogen->VanDerWaalsRadius = 1.09;
   strcpy(hydrogen->name, "hydrogen");
   strcpy(hydrogen->symbol, "H");
   carbon = new element;
-  carbon->Z = 1;
+  carbon->Z = 2;
+  carbon->CovalentRadius = 0.68;
+  carbon->VanDerWaalsRadius = 1.7;
   strcpy(carbon->name, "carbon");
   strcpy(carbon->symbol, "C");
@@ -57,17 +63,17 @@
   TestMolecule = new molecule(tafel);
   Walker = new atom();
-  Walker->type = hydrogen;
+  Walker->type = carbon;
   Walker->node->Init(1., 0., 1. );
   TestMolecule->AddAtom(Walker);
   Walker = new atom();
-  Walker->type = hydrogen;
+  Walker->type = carbon;
   Walker->node->Init(0., 1., 1. );
   TestMolecule->AddAtom(Walker);
   Walker = new atom();
-  Walker->type = hydrogen;
+  Walker->type = carbon;
   Walker->node->Init(1., 1., 0. );
   TestMolecule->AddAtom(Walker);
   Walker = new atom();
-  Walker->type = hydrogen;
+  Walker->type = carbon;
   Walker->node->Init(0., 0., 0. );
   TestMolecule->AddAtom(Walker);
@@ -77,4 +83,5 @@
 
   // create a small file with table
+  dummyname = new string("dummy.dat");
   filename = new string("test.dat");
   ofstream test(filename->c_str());
@@ -82,4 +89,5 @@
   test << "H\t1.\t1.2\n";
   test << "C\t1.2\t1.5\n";
+  test.close();
   BG = new BondGraph(true);
 };
@@ -91,4 +99,5 @@
   remove(filename->c_str());
   delete(filename);
+  delete(dummyname);
   delete(BG);
 
@@ -112,5 +121,5 @@
 /** UnitTest for BondGraphTest::ConstructBondGraph().
  */
-void BondGraphTest::ConstructGraphTest()
+void BondGraphTest::ConstructGraphFromTableTest()
 {
   atom *Walker = TestMolecule->start->next;
@@ -118,4 +127,16 @@
   CPPUNIT_ASSERT( TestMolecule->end != Walker );
   CPPUNIT_ASSERT_EQUAL( true , BG->LoadBondLengthTable(*filename) );
+  CPPUNIT_ASSERT_EQUAL( true , BG->ConstructBondGraph(TestMolecule) );
+  CPPUNIT_ASSERT_EQUAL( true , Walker->IsBondedTo(Runner) );
+};
+
+/** UnitTest for BondGraphTest::ConstructBondGraph().
+ */
+void BondGraphTest::ConstructGraphFromCovalentRadiiTest()
+{
+  atom *Walker = TestMolecule->start->next;
+  atom *Runner = TestMolecule->end->previous;
+  CPPUNIT_ASSERT( TestMolecule->end != Walker );
+  CPPUNIT_ASSERT_EQUAL( false , BG->LoadBondLengthTable(*dummyname) );
   CPPUNIT_ASSERT_EQUAL( true , BG->ConstructBondGraph(TestMolecule) );
   CPPUNIT_ASSERT_EQUAL( true , Walker->IsBondedTo(Runner) );
Index: src/unittests/bondgraphunittest.hpp
===================================================================
--- src/unittests/bondgraphunittest.hpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/unittests/bondgraphunittest.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -11,6 +11,6 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#include "bondgraph.hpp"
 
+class BondGraph;
 class element;
 class molecule;
@@ -23,5 +23,6 @@
     CPPUNIT_TEST_SUITE( BondGraphTest) ;
     CPPUNIT_TEST ( LoadTableTest );
-    CPPUNIT_TEST ( ConstructGraphTest );
+    CPPUNIT_TEST ( ConstructGraphFromTableTest );
+    CPPUNIT_TEST ( ConstructGraphFromCovalentRadiiTest );
     CPPUNIT_TEST_SUITE_END();
 
@@ -30,5 +31,6 @@
       void tearDown();
       void LoadTableTest();
-      void ConstructGraphTest();
+      void ConstructGraphFromTableTest();
+      void ConstructGraphFromCovalentRadiiTest();
 
 private:
@@ -41,4 +43,5 @@
       BondGraph *BG;
       string *filename;
+      string *dummyname;
 };
 
Index: src/unittests/gslmatrixsymmetricunittest.cpp
===================================================================
--- src/unittests/gslmatrixsymmetricunittest.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
+++ src/unittests/gslmatrixsymmetricunittest.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -0,0 +1,288 @@
+/*
+ * gslmatrixunittest.cpp
+ *
+ *  Created on: Jan 8, 2010
+ *      Author: heber
+ */
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "gslmatrixsymmetricunittest.hpp"
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( GSLMatrixSymmetricTest );
+
+
+void GSLMatrixSymmetricTest::setUp()
+{
+  m = new GSLMatrix(3,3);
+};
+
+void GSLMatrixSymmetricTest::tearDown()
+{
+  delete(m);
+};
+
+/** Unit Test for accessing matrix elements.
+ *
+ */
+void GSLMatrixSymmetricTest::AccessTest()
+{
+  // check whether all elements are initially zero
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( 0., m->Get(i,j) );
+
+  // set
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      m->Set(i,j, i*3+j );
+
+  // and check
+  double *ptr = NULL;
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++) {
+      CPPUNIT_ASSERT_EQUAL( (double)(i*3+j), m->Get(i,j) );
+      ptr = m->Pointer(i,j);
+      CPPUNIT_ASSERT_EQUAL( (double)(i*3+j), *ptr );
+    }
+
+  // assignment
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      m->Set(i,j, i*3+j );
+  GSLMatrix *dest = new GSLMatrix(3,3);
+  *dest = *m;
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( dest->Get(i,j), m->Get(i,j) );
+  delete(dest);
+
+  // out of bounds
+  //CPPUNIT_ASSERT_EQUAL(0., v->Get(4,2) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->Get(2,17) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->Get(1024,140040) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->Get(-1,0) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->Get(0,-1) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->Get(-1,-1) );
+};
+
+/** Unit Test for initializating matrices.
+ *
+ */
+void GSLMatrixSymmetricTest::InitializationTest()
+{
+  // set zero
+  m->SetZero();
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( 0., m->Get(i,j) );
+
+  // set all
+  m->SetAll(1.5);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( 1.5, m->Get(i,j) );
+
+  // set basis
+  m->SetIdentity();
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( i == j ? 1. : 0. , m->Get(i,j) );
+
+  // set from array
+  double array[] = { 1., 0., 0.,
+                     0., 1., 0.,
+                     0., 0., 1. };
+  m->SetFromDoubleArray(array);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( i == j ? 1. : 0. , m->Get(i,j) );
+
+};
+
+/** Unit Test for copying matrices.
+ *
+ */
+void GSLMatrixSymmetricTest::CopyTest()
+{
+  // set basis
+  GSLMatrix *dest = NULL;
+  for (int i=0;i<3;i++) {
+    m->SetAll(i);
+    dest = new GSLMatrix(m);
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( m->Get(i,j) , dest->Get(i,j) );
+
+    delete(dest);
+  }
+};
+
+/** Unit Test for exchanging rows and columns.
+ *
+ */
+void GSLMatrixSymmetricTest::ExchangeTest()
+{
+  // set to 1,1,1,2, ...
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      m->Set(i,j, i+1 );
+
+  // swap such that nothing happens
+  m->SwapColumns(1,2);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)i+1., m->Get(i,j) );
+
+  // swap two rows
+  m->SwapRows(1,2);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      switch (j) {
+        case 0:
+          CPPUNIT_ASSERT_EQUAL( 1., m->Get(j,i) );
+          break;
+        case 1:
+          CPPUNIT_ASSERT_EQUAL( 3., m->Get(j,i) );
+          break;
+        case 2:
+          CPPUNIT_ASSERT_EQUAL( 2., m->Get(j,i) );
+          break;
+        default:
+          CPPUNIT_ASSERT_EQUAL( -1., m->Get(i,j) );
+      }
+  // check that op is reversable
+  m->SwapRows(1,2);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)i+1., m->Get(i,j) );
+
+  // set to 1,2,3,1, ...
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      m->Set(i,j, j+1. );
+
+  // swap such that nothing happens
+  m->SwapRows(0,2);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)j+1., m->Get(i,j) );
+
+  // swap two columns
+  m->SwapColumns(0,2);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      switch (j) {
+        case 0:
+          CPPUNIT_ASSERT_EQUAL( 3., m->Get(i,j) );
+          break;
+        case 1:
+          CPPUNIT_ASSERT_EQUAL( 2., m->Get(i,j) );
+          break;
+        case 2:
+          CPPUNIT_ASSERT_EQUAL( 1., m->Get(i,j) );
+          break;
+        default:
+          CPPUNIT_ASSERT_EQUAL( -1., m->Get(i,j) );
+      }
+  // check that op is reversable
+  m->SwapColumns(0,2);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)j+1., m->Get(i,j) );
+
+
+  // set to 1,2,3,4, ...
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      m->Set(i,j, 3*i+j+1 );
+  // transpose
+  m->Transpose();
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)(3*i+j+1), m->Get(j,i) );
+  // second transpose
+  m->Transpose();
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)(3*i+j+1), m->Get(i,j) );
+};
+
+/** Unit Test for matrix properties.
+ *
+ */
+void GSLMatrixSymmetricTest::PropertiesTest()
+{
+  // is zero
+  m->SetZero();
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNull() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsPositive() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNegative() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNonNegative() );
+
+  // is positive
+  m->SetAll(0.5);
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNull() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsPositive() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNegative() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNonNegative() );
+
+  // is negative
+  m->SetAll(-0.1);
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNull() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsPositive() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNegative() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNonNegative() );
+
+  // is positive definite
+  double array[] = { 1., 0., 0.,
+                     0., 1., 1.,
+                     0., 0., 1. };
+  m->SetFromDoubleArray(array);
+  CPPUNIT_ASSERT_EQUAL( true, m->IsPositiveDefinite() );
+
+  //determinant
+  m->SetIdentity();
+  CPPUNIT_ASSERT_EQUAL( 1., m->Determinant() );
+
+  m->SetZero();
+  CPPUNIT_ASSERT_EQUAL( 0., m->Determinant() );
+
+  m->Set( 0, 0, 1.);
+  m->Set( 1, 1, 1.);
+  m->Set( 2, 1, 1.);
+  CPPUNIT_ASSERT_EQUAL( 0., m->Determinant() );
+  
+  double array2[] = { 2., 0., 1.,
+                     -3., 1., 1.,
+                     1., 5.5, 1. };
+  m->SetFromDoubleArray(array2);
+  CPPUNIT_ASSERT_EQUAL( -26.5, m->Determinant() );
+};
+
+/********************************************** Main routine **************************************/
+
+int main(int argc, char **argv)
+{
+  // Get the top level suite from the registry
+  CppUnit::Test *suite = CppUnit::TestFactoryRegistry::getRegistry().makeTest();
+
+  // Adds the test to the list of test to run
+  CppUnit::TextUi::TestRunner runner;
+  runner.addTest( suite );
+
+  // Change the default outputter to a compiler error format outputter
+  runner.setOutputter( new CppUnit::CompilerOutputter( &runner.result(),
+                                                       std::cerr ) );
+  // Run the tests.
+  bool wasSucessful = runner.run();
+
+  // Return error code 1 if the one of test failed.
+  return wasSucessful ? 0 : 1;
+};
Index: src/unittests/gslmatrixsymmetricunittest.hpp
===================================================================
--- src/unittests/gslmatrixsymmetricunittest.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
+++ src/unittests/gslmatrixsymmetricunittest.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -0,0 +1,42 @@
+/*
+ * gslmatrixunittest.hpp
+ *
+ *  Created on: Jan 8, 2010
+ *      Author: heber
+ */
+
+#ifndef GSLMATRIXUNITTEST_HPP_
+#define GSLMATRIXUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+#include "gslmatrix.hpp"
+
+/********************************************** Test classes **************************************/
+
+class GSLMatrixSymmetricTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( GSLMatrixSymmetricTest) ;
+    CPPUNIT_TEST (AccessTest );
+    CPPUNIT_TEST (InitializationTest );
+    CPPUNIT_TEST (CopyTest );
+    CPPUNIT_TEST (ExchangeTest );
+    CPPUNIT_TEST (PropertiesTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+    void setUp();
+    void tearDown();
+
+    void AccessTest();
+    void InitializationTest();
+    void CopyTest();
+    void ExchangeTest();
+    void PropertiesTest();
+
+private:
+    GSLMatrix *m;
+};
+
+
+#endif /* GSLMATRIXUNITTEST_HPP_ */
Index: src/unittests/gslmatrixunittest.cpp
===================================================================
--- src/unittests/gslmatrixunittest.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
+++ src/unittests/gslmatrixunittest.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -0,0 +1,270 @@
+/*
+ * gslmatrixunittest.cpp
+ *
+ *  Created on: Jan 8, 2010
+ *      Author: heber
+ */
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "gslmatrixunittest.hpp"
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( GSLMatrixTest );
+
+
+void GSLMatrixTest::setUp()
+{
+  m = new GSLMatrix(4,3);
+};
+
+void GSLMatrixTest::tearDown()
+{
+  delete(m);
+};
+
+/** Unit Test for accessing matrix elements.
+ *
+ */
+void GSLMatrixTest::AccessTest()
+{
+  // check whether all elements are initially zero
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( 0., m->Get(i,j) );
+
+  // set
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      m->Set(i,j, i*3+j );
+
+  // and check
+  double *ptr = NULL;
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++) {
+      CPPUNIT_ASSERT_EQUAL( (double)(i*3+j), m->Get(i,j) );
+      ptr = m->Pointer(i,j);
+      CPPUNIT_ASSERT_EQUAL( (double)(i*3+j), *ptr );
+    }
+
+  // assignment
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      m->Set(i,j, i*3+j );
+  GSLMatrix *dest = new GSLMatrix(4,3);
+  *dest = *m;
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( dest->Get(i,j), m->Get(i,j) );
+  delete(dest);
+
+  // out of bounds
+  //CPPUNIT_ASSERT_EQUAL(0., v->Get(5,2) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->Get(2,17) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->Get(1024,140040) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->Get(-1,0) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->Get(0,-1) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->Get(-1,-1) );
+};
+
+/** Unit Test for initializating matrices.
+ *
+ */
+void GSLMatrixTest::InitializationTest()
+{
+  // set zero
+  m->SetZero();
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( 0., m->Get(i,j) );
+
+  // set all
+  m->SetAll(1.5);
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( 1.5, m->Get(i,j) );
+
+  // set basis
+  m->SetIdentity();
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( i == j ? 1. : 0. , m->Get(i,j) );
+
+  // set from array
+  double array[] = { 1., 0., 0.,
+                     0., 1., 0.,
+                     0., 0., 1.,
+                     0., 0., 0. };
+  m->SetFromDoubleArray(array);
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( i == j ? 1. : 0. , m->Get(i,j) );
+
+};
+
+/** Unit Test for copying matrices.
+ *
+ */
+void GSLMatrixTest::CopyTest()
+{
+  // set basis
+  GSLMatrix *dest = NULL;
+  for (int i=0;i<4;i++) {
+    m->SetAll(i);
+    dest = new GSLMatrix(m);
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( m->Get(i,j) , dest->Get(i,j) );
+
+    delete(dest);
+  }
+};
+
+/** Unit Test for exchanging rows and columns.
+ *
+ */
+void GSLMatrixTest::ExchangeTest()
+{
+  // set to 1,1,1,2, ...
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      m->Set(i,j, i+1 );
+
+  // swap such that nothing happens
+  CPPUNIT_ASSERT_EQUAL( true, m->SwapColumns(1,2) );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)i+1., m->Get(i,j) );
+
+  // swap two rows
+  CPPUNIT_ASSERT_EQUAL( true, m->SwapRows(1,2) );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      switch (i) {
+        case 0:
+          CPPUNIT_ASSERT_EQUAL( 1., m->Get(i,j) );
+          break;
+        case 1:
+          CPPUNIT_ASSERT_EQUAL( 3., m->Get(i,j) );
+          break;
+        case 2:
+          CPPUNIT_ASSERT_EQUAL( 2., m->Get(i,j) );
+          break;
+        case 3:
+          CPPUNIT_ASSERT_EQUAL( 4., m->Get(i,j) );
+          break;
+        default:
+          CPPUNIT_ASSERT_EQUAL( -1., m->Get(i,j) );
+      }
+  // check that op is reversable
+  CPPUNIT_ASSERT_EQUAL( true, m->SwapRows(1,2) );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)i+1., m->Get(i,j) );
+
+  // set to 1,2,3,1, ...
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      m->Set(i,j, j+1. );
+
+  // swap such that nothing happens
+  CPPUNIT_ASSERT_EQUAL( true, m->SwapRows(0,2) );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)j+1., m->Get(i,j) );
+
+  // swap two columns
+  CPPUNIT_ASSERT_EQUAL( true, m->SwapColumns(0,2) );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      switch (j) {
+        case 0:
+          CPPUNIT_ASSERT_EQUAL( 3., m->Get(i,j) );
+          break;
+        case 1:
+          CPPUNIT_ASSERT_EQUAL( 2., m->Get(i,j) );
+          break;
+        case 2:
+          CPPUNIT_ASSERT_EQUAL( 1., m->Get(i,j) );
+          break;
+        default:
+          CPPUNIT_ASSERT_EQUAL( -1., m->Get(i,j) );
+      }
+  // check that op is reversable
+  CPPUNIT_ASSERT_EQUAL( true, m->SwapColumns(0,2) );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)j+1., m->Get(i,j) );
+
+
+  // set to 1,2,3,4, ...
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      m->Set(i,j, 3*i+j+1 );
+  // transpose
+  CPPUNIT_ASSERT_EQUAL( true, m->Transpose() );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)(3*i+j+1), m->Get(j,i) );
+  // second transpose
+  CPPUNIT_ASSERT_EQUAL( true, m->Transpose() );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)(3*i+j+1), m->Get(i,j) );
+};
+
+/** Unit Test for matrix properties.
+ *
+ */
+void GSLMatrixTest::PropertiesTest()
+{
+  // is zero
+  m->SetZero();
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNull() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsPositive() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNegative() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNonNegative() );
+
+  // is positive
+  m->SetAll(0.5);
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNull() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsPositive() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNegative() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNonNegative() );
+
+  // is negative
+  m->SetAll(-0.1);
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNull() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsPositive() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNegative() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNonNegative() );
+
+  // is positive definite
+  CPPUNIT_ASSERT_EQUAL( false, m->IsPositiveDefinite() );
+};
+
+/********************************************** Main routine **************************************/
+
+int main(int argc, char **argv)
+{
+  // Get the top level suite from the registry
+  CppUnit::Test *suite = CppUnit::TestFactoryRegistry::getRegistry().makeTest();
+
+  // Adds the test to the list of test to run
+  CppUnit::TextUi::TestRunner runner;
+  runner.addTest( suite );
+
+  // Change the default outputter to a compiler error format outputter
+  runner.setOutputter( new CppUnit::CompilerOutputter( &runner.result(),
+                                                       std::cerr ) );
+  // Run the tests.
+  bool wasSucessful = runner.run();
+
+  // Return error code 1 if the one of test failed.
+  return wasSucessful ? 0 : 1;
+};
Index: src/unittests/gslmatrixunittest.hpp
===================================================================
--- src/unittests/gslmatrixunittest.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
+++ src/unittests/gslmatrixunittest.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -0,0 +1,42 @@
+/*
+ * gslmatrixunittest.hpp
+ *
+ *  Created on: Jan 8, 2010
+ *      Author: heber
+ */
+
+#ifndef GSLMATRIXUNITTEST_HPP_
+#define GSLMATRIXUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+#include "gslmatrix.hpp"
+
+/********************************************** Test classes **************************************/
+
+class GSLMatrixTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( GSLMatrixTest) ;
+    CPPUNIT_TEST (AccessTest );
+    CPPUNIT_TEST (InitializationTest );
+    CPPUNIT_TEST (CopyTest );
+    CPPUNIT_TEST (ExchangeTest );
+    CPPUNIT_TEST (PropertiesTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+    void setUp();
+    void tearDown();
+
+    void AccessTest();
+    void InitializationTest();
+    void CopyTest();
+    void ExchangeTest();
+    void PropertiesTest();
+
+private:
+    GSLMatrix *m;
+};
+
+
+#endif /* GSLMATRIXUNITTEST_HPP_ */
